#include <Xm/Xm.h>
#include <Xm/DrawingA.h>
#include "global.h"

void mouse_trap(Widget widget, XtPointer client_data, XEvent *event, char *text) {

  Display       *dpy=XtDisplay(drawing_a);
  Window        window=XtWindow(drawing_a);
  GC            gc;
  XButtonEvent  *b_event;
  XMotionEvent  *m_event;
  static int    x_alt, x_neu, y_alt, y_neu;
  int           i, yunits, yoff, yoffset, chn;
  Dimension     wd, ht;
  float         dy, t, t_alt, dt;
  int           t_std, t_min, t_sec, t_msec, t_usec;
  int           dt_std, dt_min, dt_sec, dt_msec, dt_usec;
  unsigned long n;
  char          message[256];

  extern void set_color(Widget widget, String fgcolor, String bgcolor, GC gc);

  if (r.n>0) {
    gc=XCreateGC(XtDisplay(drawing_a),
		 RootWindowOfScreen(XtScreen(drawing_a)), 0, NULL);

    if (event->type==ButtonPress) {
      b_event=(XButtonEvent *) event;
      if (b_event->button==Button1) {
	if (b_event->x >= LMAR) {
	  x_alt=b_event->x; x_neu=b_event->x;
	}
	else {
	  x_alt=LMAR; x_neu=LMAR;
	}
	y_alt=b_event->y; y_neu=b_event->y;
	XSetFunction(dpy, gc, GXxor);
	set_color(drawing_a, "white", NULL, gc);
	XDrawPoint(dpy,window,gc, x_alt, y_alt);
      }
      if (b_event->button==Button2) {
	XtVaGetValues(drawing_a, XmNwidth, &wd, XmNheight, &ht, NULL);
	yunits=0;
	for (i=0; i<r.n; i++)
	  if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
	dy=(float)ht/(float)yunits;
	yoff=0;
	for (i=0; i<r.n; i++) {
	  if (r.view[i].is_visible) {
	    if ((b_event->y >= yoff) &&
		(b_event->y < yoff+dy*(r.ch[i].height+1)) ) {
	      chn=i; yoffset=yoff;
	    }
	    yoff+=(int)(dy*(r.ch[i].height+1));
	  }
	}
	if (r.view[chn].is_active) {
	  r.view[chn].is_active=0;
	  set_color(drawing_a, "red", "White", gc);
	  XDrawImageString(dpy, window, gc, 0, yoffset+15,
			   "P", strlen("P")); 
	  set_color(drawing_a, "black", NULL, gc);
	}
	else {
	  r.view[chn].is_active=1;
	  set_color(drawing_a, "blue", "White", gc);
	  XDrawImageString(dpy, window, gc, 0, yoffset+15,
			   "A", strlen("A")); 
	  set_color(drawing_a, "black", NULL, gc);
	}
      }
    }
    if (event->type==ButtonRelease) {
      b_event=(XButtonEvent *) event;
      if (b_event->button==Button1) {
	XtVaGetValues(drawing_a, XmNwidth, &wd, XmNheight, &ht, NULL);
	if(x_alt>x_neu) {
	  r.ts_1=r.t_1+(float)(x_neu-LMAR)*(r.t_2-r.t_1)/(float)(wd-LMAR);
	  r.ts_2=r.t_1+(float)(x_alt-LMAR)*(r.t_2-r.t_1)/(float)(wd-LMAR);
	}
	else {
	  r.ts_1=r.t_1+(float)(x_alt-LMAR)*(r.t_2-r.t_1)/(float)(wd-LMAR);
	  r.ts_2=r.t_1+(float)(x_neu-LMAR)*(r.t_2-r.t_1)/(float)(wd-LMAR);
	}
	set_color(drawing_a, "red", NULL, gc);
	XDrawLine(dpy,window,gc, x_alt, y_alt, x_neu, y_alt);
	XDrawLine(dpy,window,gc, x_neu, y_alt, x_neu, y_neu);
	XDrawLine(dpy,window,gc, x_neu, y_neu, x_alt, y_neu);
	XDrawLine(dpy,window,gc, x_alt, y_neu, x_alt, y_alt);
	set_color(drawing_a, "black", NULL, gc);
      }
    }
    if (event->type==MotionNotify) {
      m_event=(XMotionEvent *) event;
      XtVaGetValues(drawing_a, XmNwidth, &wd, XmNheight, &ht, NULL);
      if (m_event->state == Button1Mask) {
	XSetFunction(dpy, gc, GXxor);
	set_color(drawing_a, "white", NULL, gc);
	XDrawLine(dpy,window,gc, x_alt, y_alt, x_neu, y_alt);
	XDrawLine(dpy,window,gc, x_neu, y_alt, x_neu, y_neu);
	XDrawLine(dpy,window,gc, x_neu, y_neu, x_alt, y_neu);
	XDrawLine(dpy,window,gc, x_alt, y_neu, x_alt, y_alt);
	x_neu=m_event->x; y_neu=m_event->y;
	if (x_neu<LMAR) x_neu=LMAR;
	if (x_neu>wd) x_neu=wd;
	if (y_neu<0) y_neu=0;
	if (y_neu>ht) y_neu=ht;
	XDrawLine(dpy,window,gc, x_alt, y_alt, x_neu, y_alt);
	XDrawLine(dpy,window,gc, x_neu, y_alt, x_neu, y_neu);
	XDrawLine(dpy,window,gc, x_neu, y_neu, x_alt, y_neu);
	XDrawLine(dpy,window,gc, x_alt, y_neu, x_alt, y_alt);
	XSetFunction(dpy, gc, GXcopy);
      }
      yunits=0;
      for (i=0; i<r.n; i++)
	if (r.view[i].is_visible) yunits+=r.ch[i].height+1;
      dy=(float)ht/(float)yunits;
      yoff=0; chn=-1;
      for (i=0; i<r.n; i++) {
	if (r.view[i].is_visible) {
	  if ((m_event->y >= yoff) &&
	      (m_event->y < yoff+dy*(r.ch[i].height+1)) ) {
	    chn=i; yoffset=yoff;
	  }
	  yoff+=(int)(dy*(r.ch[i].height+1));
	}
      }
      if (m_event->x>=0 && m_event->x<=wd && chn>=0) {
	if (m_event->x<LMAR) t=r.t_1;
	else
	  t=r.t_1+(float)(m_event->x-LMAR)*(r.t_2-r.t_1)/(float)(wd-LMAR);
	if (t<0) t=0;
	n=(unsigned long)(t*r.ch[chn].sr);
	if (n>=r.ch[chn].n) n=r.ch[chn].n-1;
	if (n<0) n=0;
	if (r.view[chn].is_frequency) {
	  sprintf(message, "ch%d: %.3f %.6f",
		  chn+1, ((float)n*0.5*r.ch[chn].sr)/((float)(r.ch[chn].n-1)), 
		  r.ch[chn].data[n]);
	}
	else {
	  if (m_event->state == Button1Mask) {
	    t_std=(int)(floor(t/3600));
	    t_min=(int)(floor((t-t_std*3600)/60));
	    t_sec=(int)(t-t_std*3600-t_min*60);
	    t_msec=(int)((t-t_std*3600-t_min*60-t_sec)*1000);
	    /* t_usec=(int)(((t-t_std*3600-t_min*60-t_sec)*1000.0-t_msec)*1000); */

	    t_alt=r.t_1+(float)(x_alt-LMAR)*(r.t_2-r.t_1)/(float)(wd-LMAR);
	    dt=fabs(t-t_alt);
	    dt_std=(int)(floor(dt/3600));
	    dt_min=(int)(floor((dt-dt_std*3600)/60));
	    dt_sec=(int)(dt-dt_std*3600-dt_min*60);
	    dt_msec=(int)((dt-dt_std*3600-dt_min*60-dt_sec)*1000);

	    sprintf(message,"ch%d: t: %.2d:%.2d:%.2d:%.3d Dt: %.2d:%.2d:%.2d:%.3d value: %.3f",
		    chn+1, t_std, t_min, t_sec, t_msec, 
		    dt_std, dt_min, dt_sec, dt_msec, r.ch[chn].data[n]);
	  }
	  else {
	    t_std=(int)(floor(t/3600));
	    t_min=(int)(floor((t-t_std*3600)/60));
	    t_sec=(int)(t-t_std*3600-t_min*60);
	    t_msec=(int)((t-t_std*3600-t_min*60-t_sec)*1000);
	    /* t_usec=(int)(((t-t_std*3600-t_min*60-t_sec)*1000.0-t_msec)*1000); */
	    sprintf(message,"ch%d: %.2d:%.2d:%.2d:%.3d %.3f",
		    chn+1, t_std, t_min, t_sec, t_msec, 
		    r.ch[chn].data[n]);
	  }
	}
	XtVaSetValues(mess.l,
		      XtVaTypedArg, XmNlabelString, XmRString,
		      message, strlen(message)+1, NULL);
      }
    }
    
    XFreeGC(dpy,gc);
  }
}
